![partial.js logo](http://petersirka.sk/partial-js/logo-new.png)

web application framework for node.js
=====================================

- [partial.js homepage - www.partialjs.com](http://partialjs.com)
- [__Documentation__](http://docs.partialjs.com)
- [Discussion forum](https://groups.google.com/forum/#!forum/partialjs)
- [Changelog](https://github.com/petersirka/partial.js/blob/master/changes.txt)
- [__Roadmap__](https://github.com/petersirka/partial.js/blob/master/roadmap.txt)

__Interesting__:

- [__express.js vs partial.js__](http://www.partialjs.com/benefits/)
- [Tutorial](http://docs.partialjs.com/tutorial/)
- [Download __partial.js modules__](https://github.com/petersirka/partial.js-modules/)
- [Download empty project](http://www.partialjs.com/upload/empty-project.zip)
- Framework supports [NoSQL Embedded database](https://github.com/petersirka/nosql) for max. 20 000 documents per database

__Social networks__:

- [__Discussion forum__](https://groups.google.com/forum/#!forum/partialjs)
- [Flattr partial.js](http://flattr.com/thing/1436218/partial-js-web-application-framework-for-node-js)
- [Follow partial.js on GitHub](https://github.com/petersirka/partial.js)
- [Follow partial.js on Twitter - __@partialjs__](https://twitter.com/partialjs)
- [Follow partial.js on Facebook](https://www.facebook.com/partialjs)
- [Follow partial.js on Google Plus](https://plus.google.com/u/0/113175077493180148081/posts)

__Examples__:

- [More than 50 examples](https://github.com/petersirka/partial.js/tree/master/examples)
- Older code: [blog written in partial.js (without installation)](http://blog.partialjs.com)
- Older code: [e-shop written in partial.js (without installation)](http://eshop.partialjs.com)

Documentation
-------------
- [English documentation](http://docs.partialjs.com/)
- [Turkish documentation](https://github.com/KiPSOFT/partial.js-turkish-doc/blob/master/baslangic.md) by [KiP Software](http://www.kip-software.org/)

***

Videos on YouTube
-----------------

- [HTML 5 Server-Sent Events (JavaScript) via partial.js & node.js](http://www.youtube.com/watch?v=XoWIv3xGxR4)
- [node.js / partial.js - Live streaming via multipart/x-mixed-replace + CSS auto vendor prefix](http://www.youtube.com/watch?v=qZqO4c4Fw2k)
- [Deployment of partial.js / node.js website on appfog.com (freehosting)](http://www.youtube.com/watch?v=kZvCCyR6iBI)
- [WebSocket (Real-time) HTML5 Chat in 5 minutes - node.js & partial.js](http://www.youtube.com/watch?v=lW1vsKMUaKg)
- [partial.js / web application framework for node.js](http://www.youtube.com/watch?v=3GMQJki82Lo)

***

* **NEW** - Supports redirects - [example: host redirect](https://github.com/petersirka/partial.js/tree/master/examples/redirect-host)
* **NEW** - Supports restrictions - [example: restrictions](https://github.com/petersirka/partial.js/tree/master/examples/framework-restrictions)
* __Controller proxy__ - [example: proxy](https://github.com/petersirka/partial.js/tree/master/examples/controller-proxy)
* Supports server sent events - [example: sse](https://github.com/petersirka/partial.js/tree/master/examples/server-sent-events)
* Supports live streaming via multipart/x-mixed-replace - [example: mmr](https://github.com/petersirka/partial.js/tree/master/examples/live-streaming)
* Supports uploading via multipart/x-mixed-replace - [example: mmr](https://github.com/petersirka/partial.js/tree/master/examples/live-streaming-upload)
* Supports CSS auto vendor prefixes - [read the benefits](http://www.partialjs.com/benefits/)
* Supports Websocket (Standard - RFC 6455) - [example: websocket](https://github.com/petersirka/partial.js/tree/master/examples/websocket)
* Async web framework - [example: async methods](https://github.com/petersirka/partial.js/tree/master/examples/async)
* Simple view engine - [example: view engine](https://github.com/petersirka/partial.js/tree/master/examples/views)
* Simple routing + support flags ['xhr', 'post', 'put', 'delete', 'upload', 'logged', etc.] - [example: routing flags](https://github.com/petersirka/partial.js/tree/master/examples/routing-flags)
* Simple cacheing - [http cache example](https://github.com/petersirka/partial.js/tree/master/examples/cache-http), [partial cache example](https://github.com/petersirka/partial.js/tree/master/examples/cache-partial)
* Simple directory structure (controllers, modules, public, logs, tmp, templates, views, resources)
* Simple code structure
* Simple error handling
* Simple cookie manipulation - [example: cookies](https://github.com/petersirka/partial.js/tree/master/examples/cookies)
* Simple listing via templates - [example: listing via templates](https://github.com/petersirka/partial.js/tree/master/examples/templating)
* XSS protection [example: XSS](https://github.com/petersirka/partial.js/tree/master/examples/framework-xss-protection)
* Share controller functions and models over the framework - [example](https://github.com/petersirka/partial.js/tree/master/examples/controller-sharing)
* __Assertion Testing__ - [example: testing](https://github.com/petersirka/partial.js/tree/master/examples/testing)
* Supports custom helpers - [example: custom helpers](https://github.com/petersirka/partial.js/tree/master/examples/View-custom-helper)
* Supports routing to static file for dynamic creating static file - [example: routing](https://github.com/petersirka/partial.js/tree/master/examples/routing)
* Supports controller sharing between other controllers - [example](https://github.com/petersirka/partial.js/tree/master/examples/controller-sharing)
* Supports debug mode with custom settings without cache - [example: debug mode](https://github.com/petersirka/partial.js/tree/master/examples/config-debug-release)
* Supports file upload - [example: file upload](https://github.com/petersirka/partial.js/tree/master/examples/upload-multipart)
* Supports copy&paste custom code between projects - [example](https://github.com/petersirka/partial.js/tree/master/examples/framework-custom)
* __Supports modules__ (module can create a route, view, template, content, resource, etc.) - [example: module](https://github.com/petersirka/partial.js/tree/master/examples/framework-modules)
* __Supports inject module from URL__ [example: module inject](https://github.com/petersirka/partial.js/tree/master/examples/framework-inject)
* Supports form data validation - [example: validation](https://github.com/petersirka/partial.js/tree/master/examples/validation)
* Supports simple log writer - [example: logs](https://github.com/petersirka/partial.js/tree/master/examples/logs)
* Supports simple restrictions [example: restriction](https://github.com/petersirka/partial.js/tree/master/examples/restrictions-ip)
* Supports serve static files
* __Supports streaming static files__ - implemented Accept-Ranges
* Supports HTML minification
* Supports JavaScript compress
* Supports JavaScript dynamic compress in views - [example: dynamic JavaScript compress](https://github.com/petersirka/partial.js/tree/master/examples/views-javascript-compress)
* Supports simple LESS CSS (with compress) - [example: LESS CSS](https://github.com/petersirka/partial.js/tree/master/examples/css-less)
* Supports Markdown parser - [example: Markdown](https://github.com/petersirka/partial.js/tree/master/examples/markdown)
* Supports resources (for multilanguage pages) - [example: resources](https://github.com/petersirka/partial.js/tree/master/examples/localization-resources)
* __Supports prefixes for mobile devices__ - [example: prefixes](https://github.com/petersirka/partial.js/tree/master/examples/mobile)
* Supports SMTP mail sender (attachment, HTML, basic authentication) - [example: SMTP mail sender](https://github.com/petersirka/partial.js/tree/master/examples/email-templating)
* Supports simple mail templating - [example: mail templating](https://github.com/petersirka/partial.js/tree/master/examples/email-templating)
* Supports custom authorization - [example: authorization](https://github.com/petersirka/partial.js/tree/master/examples/authorization)
* Supports basic access authentication - [example: basic access authentication](https://github.com/petersirka/partial.js/tree/master/examples/authorization-www-basic)
* Supports simple image processing (resize, grayscale, etc.) via GraphicsMagick/ImageMagick - [example](https://github.com/petersirka/partial.js/tree/master/examples/picture-resize)
* Easy adding dynamic META tags in views or controllers - [example: meta tags](https://github.com/petersirka/partial.js/tree/master/examples/views-meta)
* Easy adding dynamic Settings in views or controllers - [example: view settings](https://github.com/petersirka/partial.js/tree/master/examples/views-settings)
* Simple use paypal payment with [node-paypal project](https://github.com/petersirka/node-paypal) - [example: paypal](https://github.com/petersirka/partial.js/tree/master/examples/paypal)
* Supports simple pagination builder - [example: pagination builder](https://github.com/petersirka/partial.js/tree/master/examples/paging)
* Supports live usage information - [example: framework usage](https://github.com/petersirka/partial.js/tree/master/examples/framework-usage)
* Supports dynamic stop server - [example: stop server](https://github.com/petersirka/partial.js/tree/master/examples/framework-stop)
* Supports verification of framework - [example: verification](https://github.com/petersirka/partial.js/tree/master/examples/framework-verification)
* __Supports backup and restore website__ - [example: backup & restore](https://github.com/petersirka/partial.js/tree/master/examples/backup-restore), [auto-backup example](https://github.com/petersirka/partial.js/tree/master/examples/auto-backup)
* About 9 000 lines of JavaScript code, all files have 330 kB
* __NO DEPENDENCIES *** NO DEPENDENCIES *** NO DEPENDENCIES__
* [More examples](https://github.com/petersirka/partial.js/tree/master/examples)
* [Documentation](http://www.partialjs.com/documentation/)
* __Supports internal NoSQL embedded database__ - [example: authorization](https://github.com/petersirka/partial.js/tree/master/examples/authorization) or [example: contact form](https://github.com/petersirka/partial.js/tree/master/examples/contact-form)

***

## WebSocket (Real-time) HTML5 Chat in 5 minutes

[![partial.js example](http://partialjs.com/img/video.jpg)](http://www.youtube.com/watch?v=lW1vsKMUaKg)

***

## Install step by step partial.js

```
$ sudo npm install -g partial.js
```
```
$ mkdir mywebsite
$ cd mywebsite
$ partial.js
```
```
$ node keepalive 8080
```
```
$ open http://127.0.0.1:8080
```

## The MIT License

Copyright (c) 2012-2013 Peter Širka <petersirka@gmail.com>

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the 'Software'), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

## Contact

[www.petersirka.sk](http://www.petersirka.sk)
